#include <stdio.h>
#include <stdlib.h>
#include "json.h"

int parse(){
    char str[200];
    char* key = NULL;
    char* val = NULL;
    JsonParser json;
    strcpy(str, "{\"name\" : \"Jack\", \"age\": 27, \"test\": true, \"tab\": [1, 2, 3, 4, 5], \"obj\": {\"name\" : \"Jack\", \"age\": 27}, \"nb\": 27.8 }");
    //Parse
    int a = json_parse(&json, str);
    printf("Parse : %d\n", a);
    //Affiche toutes les clefs : valeurs
    for(int i = 0; i < json.elt; i++){
        key = key_index(&json, i);
        val = get_index(&json, i);
        printf("%s : %s\n", key, val);
    }
    //Recup un nombre
    printf("Double : %f %.2f | Int : %d %d\n", get_number(&json, "age"), get_number(&json, "nb"), get_integer(&json, "age"), get_integer(&json, "nb"));
    //Recup boolean
    printf("Bool : %d %d\n", get_boolean(&json, "test"), get_boolean(&json, "tab"));
    //Recup obj
    JsonParser* js;
    js = get_object(&json, "obj");
    if(js != NULL){
        int key_i = get_pos(js, "name");
        printf("JSON : %s %s, age %d\n", key_index(js, key_i), get_value(js, "name"), get_integer(js, "age"));
    } else {
        printf("JSON : Error");
    }
    //Supprime
    free(key);
    free(val);
    clean_json_parser(&json);
    return 0;
}

int encode(){
    //Encode
    JsonEncoder json;
    ini_encoder(&json);
    add_string(&json, "name", "robert");
    add_number(&json, "nb", 25.698, 2);
    add_integer(&json, "int", 84);
    add_string(&json, "aze", "rty");
    add_boolean(&json, "bool", false);
    add_value(&json, "\"test\": \"aze\nrty\"");
    char * str;
    str = json_encode(&json);
    printf("%s\n", str);
    clean_json_encoder(&json);
    
    //Decode
    JsonParser parser;
    char* key, *val;
    json_parse(&parser, str);
    //Affiche toutes les clefs : valeurs
    for(int i = 0; i < parser.elt; i++){
        key = key_index(&parser, i);
        val = get_index(&parser, i);
        printf("%s : %s\n", key, val);
    }
    
    return 0;
}

int main(){
    //return parse();
    return encode();
}